#pragma once

#include "ofMain.h"
#include "ofxMaxim.h"
#include "ofxGui.h"

class ofApp : public ofBaseApp{
    
public:
    void setup();
    void update();
    void draw();
    void audioOut(float * output, int bufferSize, int nChannels);
    void drawWaveform();
    void keyPressed(int key);
    
    int sampleRate, bufferSize;
    
    maxiOsc carrier, mod, mod2;
    maxiFilter lowpass;
    ofxPanel gui;
    ofParameter<float> carrierFreq, modFreq, modIndex, gain, cutoff, resonance, modFreq2, mod2Index;
    double filterOUT;
    
    double oscOUT, modOUT, mix, mod2OUT;
    
    // used for drawing waveform
    float soundBuffer[512], pauseBuffer[512];
    
    bool pause;
};

